#define F_CPU 8000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <math.h>
#include "ds18b20.h"
#include "LCD.h"

// 123.4
// numbers[0] = 123
// numbers[1] = 4
inline void explodeDoubleNumber(int* numbers, double flt) {
	numbers[0] = abs((int) flt);
	numbers[1] = abs((int) ((flt - ((int) flt)) * 10));
}

inline void printTemp(double d) {
	char text[17] = "T=";
	int fs[2];
	char num[5];
	explodeDoubleNumber(fs, d);
	if (d < 0) {
		strcat(text, "-");
	}
	itoa(fs[0], num, 10);
	strcat(text, num);
	strcat(text, ".");
	itoa(fs[1], num, 10);
	strcat(text, num);
	strcat(text, "'C");
	lcdClear();
	lcdGotoXY(0, 0);
	lcdPuts(text);
}

int main(void) {
	_delay_ms(100);
	lcdInit();
	lcdClear();
	lcdSetDisplay(LCD_DISPLAY_ON);
	lcdSetCursor(LCD_CURSOR_OFF);

	while (1) {
		double d = getTempDS18B20();
		printTemp(d);
		_delay_ms(1000);
	}
}
// site: http://micro-pi.ru
// Program Memory Usage 	:	1944 bytes   94,9 % Full
// Data Memory Usage 		:	0 bytes   0,0 % Full